package com.oracle.coherence.util.tuples;

import com.tangosol.io.ExternalizableLite;

/**
 * An immutable sequence of values that are externalizble with Coherence
 * 
 * @author boliver
 */

public interface Tuple extends ExternalizableLite {

    /**
     * Return the number of values in the {@link Tuple}
     */
    public int size();


    /**
     * Return the value at index.  The first value is at index 0.
     * 
     * @param index
     * @throws IndexOutOfBoundsException When 0 < index <= size()
     */
    public Object get(int index) throws IndexOutOfBoundsException;

}
