package com.oracle.coherence.util.tuples;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import com.tangosol.util.ExternalizableHelper;

public class Tuple3<X, Y, Z> implements Tuple {

	private static final long serialVersionUID = 3716124635756005008L;

	private X x;
	private Y y;
	private Z z;
	
	public Tuple3() {
		//for ExternalizableLite
	}
	
	
	public Tuple3(X x, Y y, Z z) {
		this.x = x;
		this.y = y;
		this.z = z;
	}
	
	
	public Object get(int index) throws IndexOutOfBoundsException {
		if (index == 0)
			return x;
		else if (index == 1)
			return y;
		else if (index == 2)
			return z;
		else
			throw new IndexOutOfBoundsException(String.format("%d is an illegal index for a Tuple3", index));
	}

	
	public int size() {
		return 2;
	}

	
	public X getX() {
		return x;
	}
	
	
	public Y getY() {
		return y;
	}

	
	public Z getZ() {
		return z;
	}
	
	
	@SuppressWarnings("unchecked")
	public void readExternal(DataInput dataInput) throws IOException {
		x = (X)ExternalizableHelper.readObject(dataInput);
		y = (Y)ExternalizableHelper.readObject(dataInput);
		z = (Z)ExternalizableHelper.readObject(dataInput);
	}

	
	public void writeExternal(DataOutput dataOutput) throws IOException {
		ExternalizableHelper.writeObject(dataOutput, x);
		ExternalizableHelper.writeObject(dataOutput, y);
		ExternalizableHelper.writeObject(dataOutput, z);
	}

	
	@Override
	public String toString() {
		return String.format("Tuple3(%s, %s, %s)", 
								x == null ? "null" : x.toString(), 
								y == null ? "null" : y.toString(), 
								z == null ? "null" : z.toString());
	}
}
