package com.oracle.coherence.util.tuples;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import com.tangosol.util.ExternalizableHelper;

public class Tuple5<A, B, C, D, E> implements Tuple {

	private static final long serialVersionUID = 6932608907297324176L;

	private A a;
	private B b;
	private C c;
	private D d;
	private E e;
	
	public Tuple5() {
		//for ExternalizableLite
	}
	
	
	public Tuple5(A a, B b, C c, D d, E e) {
		this.a = a;
		this.b = b;
		this.c = c;
		this.d = d;
		this.e = e;
	}


	public Object get(int index) throws IndexOutOfBoundsException {
		if (index == 0)
			return a;
		else if (index == 1)
			return b;
		else if (index == 2)
			return c;
		else if (index == 3)
			return d;
		else if (index == 4)
			return e;
		else
			throw new IndexOutOfBoundsException(String.format("%d is an illegal index for a Tuple5", index));
	}

	
	public int size() {
		return 5;
	}
	
	
	public A getA() {
		return a;
	}


	public B getB() {
		return b;
	}


	public C getC() {
		return c;
	}


	public D getD() {
		return d;
	}


	public E getE() {
		return e;
	}


	@SuppressWarnings("unchecked")
	public void readExternal(DataInput dataInput) throws IOException {
		a = (A)ExternalizableHelper.readObject(dataInput);
		b = (B)ExternalizableHelper.readObject(dataInput);
		c = (C)ExternalizableHelper.readObject(dataInput);
		d = (D)ExternalizableHelper.readObject(dataInput);
		e = (E)ExternalizableHelper.readObject(dataInput);
	}

	
	public void writeExternal(DataOutput dataOutput) throws IOException {
		ExternalizableHelper.writeObject(dataOutput, a);
		ExternalizableHelper.writeObject(dataOutput, b);
		ExternalizableHelper.writeObject(dataOutput, c);
		ExternalizableHelper.writeObject(dataOutput, d);
		ExternalizableHelper.writeObject(dataOutput, e);
	}

	
	@Override
	public String toString() {
		return String.format("Tuple5(%s, %s, %s, %s, %s)", 
								a == null ? "null" : a.toString(), 
								b == null ? "null" : b.toString(), 
								c == null ? "null" : c.toString(), 
								d == null ? "null" : d.toString(), 
								e == null ? "null" : e.toString());
	}
}
